import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.text.Document;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;

public class Server extends javax.swing.JFrame {

    private final String[] smiles = {"B-)", ":@", ":-S", "<B", ":-P", ":-*", ":-D", ":'(", ":-(", ":-o"};
    private final Path path = Paths.get("users.inf");
    private TreeMap<String, InfoClass> map = new TreeMap<>();
    private String selectedUser;
    private final TreeMap<String, Object[]> onlineUsers = new TreeMap<>();

    public Server() {
        initComponents();
        setVisible(true);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        grp_users = new javax.swing.ButtonGroup();
        scr_conversation = new javax.swing.JScrollPane();
        txt_conversation = new javax.swing.JTextPane();
        jLabel1 = new javax.swing.JLabel();
        txt_message = new javax.swing.JTextField();
        btn_send = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        pnl_smile = new javax.swing.JPanel();
        pnl_setting = new javax.swing.JPanel();
        chk_accept = new javax.swing.JCheckBox();
        chk_block = new javax.swing.JCheckBox();
        scr_users = new javax.swing.JScrollPane();
        pnl_users = new javax.swing.JPanel();
        lbl_address = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Server");
        setIconImage(new ImageIcon(getClass().getResource("xchat.png")).getImage());
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        txt_conversation.setEditable(false);
        txt_conversation.setName(""); // NOI18N
        scr_conversation.setViewportView(txt_conversation);

        jLabel1.setText("Message:");

        btn_send.setText("Send");
        btn_send.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_sendActionPerformed(evt);
            }
        });

        jLabel2.setText("Smile:");

        pnl_smile.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        pnl_smile.setLayout(new java.awt.GridLayout(1, 10, 0, 3));

        pnl_setting.setBorder(javax.swing.BorderFactory.createTitledBorder("Settings"));

        chk_accept.setText("Accept");
        chk_accept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chk_acceptActionPerformed(evt);
            }
        });

        chk_block.setText("Block");
        chk_block.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chk_blockActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnl_settingLayout = new javax.swing.GroupLayout(pnl_setting);
        pnl_setting.setLayout(pnl_settingLayout);
        pnl_settingLayout.setHorizontalGroup(
            pnl_settingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_settingLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(chk_accept)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chk_block)
                .addContainerGap())
        );
        pnl_settingLayout.setVerticalGroup(
            pnl_settingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnl_settingLayout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addGroup(pnl_settingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(chk_accept)
                    .addComponent(chk_block)))
        );

        scr_users.setBorder(javax.swing.BorderFactory.createEmptyBorder(2, 2, 2, 2));

        pnl_users.setBorder(javax.swing.BorderFactory.createTitledBorder("Users"));

        javax.swing.GroupLayout pnl_usersLayout = new javax.swing.GroupLayout(pnl_users);
        pnl_users.setLayout(pnl_usersLayout);
        pnl_usersLayout.setHorizontalGroup(
            pnl_usersLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 178, Short.MAX_VALUE)
        );
        pnl_usersLayout.setVerticalGroup(
            pnl_usersLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 365, Short.MAX_VALUE)
        );

        scr_users.setViewportView(pnl_users);

        lbl_address.setText("Port:2365");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(scr_conversation)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txt_message, javax.swing.GroupLayout.DEFAULT_SIZE, 240, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btn_send, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(3, 3, 3)
                        .addComponent(pnl_smile, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(pnl_setting, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(scr_users))
                    .addComponent(lbl_address))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(scr_conversation, javax.swing.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lbl_address)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(scr_users, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                        .addGap(7, 7, 7)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txt_message, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1)
                            .addComponent(btn_send))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(pnl_smile, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addComponent(pnl_setting, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        new ServerThread().start();
        for (int i = 1; i <= 10; i++) {
            JLabel lbl = new JLabel(new ImageIcon(getClass().getResource(i + ".png")));
            lbl.addMouseListener(new SmileActionListener(i - 1));
            pnl_smile.add(lbl);
        }
        RefreshList();
        pnl_smile.revalidate();
        pnl_smile.repaint();
    }//GEN-LAST:event_formWindowOpened

    private void chk_acceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chk_acceptActionPerformed
        InfoClass info = map.get(selectedUser);
        info.setAccept(chk_accept.isSelected());
        if (!chk_accept.isSelected()) {
            onlineUsers.remove(selectedUser);
        }
        map.put(selectedUser, info);
        SaveUserFile();
        RefreshList();
    }//GEN-LAST:event_chk_acceptActionPerformed

    private void chk_blockActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chk_blockActionPerformed
        try {
            InfoClass info = map.get(selectedUser);
            info.setBlock(chk_block.isSelected());
            if (chk_block.isSelected()) {
                if (onlineUsers.containsKey(selectedUser)) {
                    ObjectInputStream ois = (ObjectInputStream) onlineUsers.get(selectedUser)[0];
                    ObjectOutputStream oos = (ObjectOutputStream) onlineUsers.get(selectedUser)[1];
                    ois.close();
                    oos.close();
                }
                onlineUsers.remove(selectedUser);
            }
            map.put(selectedUser, info);
            SaveUserFile();
            RefreshList();
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_chk_blockActionPerformed

    private void btn_sendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_sendActionPerformed
        try {
            MailBox box = new MailBox();
            box.setUsername("SERVER");
            box.setTitle("Message");
            Object[] info = new Object[]{selectedUser, txt_message.getText()};
            box.setInfo(info);
            if (onlineUsers.containsKey(selectedUser)) {
                ObjectOutputStream oos = (ObjectOutputStream) onlineUsers.get(selectedUser)[1];
                oos.writeObject(box);
                String user = "Server to " + selectedUser;
                InsertString(user, txt_message.getText() + "\n", Color.black);
            }
            txt_message.setText("");
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_btn_sendActionPerformed

    private void RefreshList() {
        LoadUserFile();
        JRadioButton rdo_selected = null;
        chk_accept.setEnabled(false);
        chk_block.setEnabled(false);
        btn_send.setEnabled(false);
        pnl_users.removeAll();
        if (map.size() <= 14) {
            pnl_users.setLayout(new GridLayout(14, 1));
        } else {
            pnl_users.setLayout(new GridLayout(0, 1));
        }
        Set<String> keySet = map.keySet();
        for (String info : keySet) {
            JRadioButton btn = new JRadioButton(info);
            btn.setName("rdo_" + info);
            InfoClass cls = map.get(info);
            if (!cls.isAccept()) {
                btn.setForeground(Color.blue);
            }
            if (cls.isBlock()) {
                btn.setForeground(Color.red);
            }
            if (onlineUsers.containsKey(info)) {
                btn.setForeground(Color.green);
            }
            btn.addActionListener((ActionEvent e) -> {
                radioButtonClick(cls, info);
            });
            if (info.equals(selectedUser)) {
                radioButtonClick(cls, info);
                rdo_selected = btn;
            }
            grp_users.add(btn);
            pnl_users.add(btn);
        }
        pnl_users.repaint();
        pnl_users.revalidate();
        if (rdo_selected != null) {
            rdo_selected.setSelected(true);
        }
        try {
            for (String key : onlineUsers.keySet()) {
                InfoClass cls = map.get(key);
                TreeSet<String> smsBlackList = cls.getSmsBlackList();
                TreeSet<String> voiceBlackList = cls.getVoiceBlackList();
                ArrayList<OnlineUser> list = new ArrayList<>();
                for (String tmp : onlineUsers.keySet()) {
                    OnlineUser line = new OnlineUser();
                    line.setUsername(tmp);
                    if (smsBlackList.contains(tmp)) {
                        line.setSmsBlock(true);
                    } else{
                        line.setSmsBlock(false);
                    }
                    if (voiceBlackList.contains(tmp)) {
                        line.setVoiceBlock(true);
                    } else {
                        line.setVoiceBlock(false);
                    }
                    if(!tmp.equals(key))
                        list.add(line);
                }
                ObjectOutputStream oos = (ObjectOutputStream) onlineUsers.get(key)[1];
                MailBox box = new MailBox();
                box.setTitle("Users");
                Object[] info = list.toArray();
                box.setInfo(info);
                oos.writeObject(box);
            }
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    private void radioButtonClick(InfoClass cls, String info) {
        chk_accept.setSelected(cls.isAccept());
        chk_block.setSelected(cls.isBlock());
        selectedUser = info;
        chk_accept.setEnabled(true);
        chk_block.setEnabled(true);
        btn_send.setEnabled(true);
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(() -> {
            try {
                UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex) {
                JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            new Server().setVisible(true);
        });
    }

    private class SmileActionListener extends MouseAdapter {

        private int index = 0;

        public SmileActionListener(int index) {
            this.index = index;
        }

        @Override
        public void mouseReleased(MouseEvent e) {
            txt_message.setText(txt_message.getText() + smiles[index]);
        }

    }

    private class ServerThread extends Thread {

        private ServerSocket server;

        public ServerThread() {
            try {
                server = new ServerSocket(0);
                lbl_address.setText("Port: " + server.getLocalPort());
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
            }
        }

        @Override
        public void run() {
            while (true) {
                try {
                    Socket socket = server.accept();
                    new SocketClient(socket).start();
                } catch (IOException ex) {
                    JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
        }

    }

    private class SocketClient extends Thread {

        private ObjectInputStream ois = null;
        private ObjectOutputStream oos = null;

        public SocketClient(Socket socket) {
            try {
                oos = new ObjectOutputStream(socket.getOutputStream());
                ois = new ObjectInputStream(socket.getInputStream());
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
            }
        }

        @Override
        public void run() {
            String username = null;
            try {
                while (true) {
                    MailBox box = (MailBox) ois.readObject();
                    username = box.getUsername();
                    String title = box.getTitle();
                    switch (title) {
                        case "Login":
                            Login(ois, oos, box);
                            break;
                        case "SignUp":
                            SignUp(ois, oos, box);
                            break;
                        case "SmsBlock":
                            SmsBlock(ois, oos, box);
                            break;
                        case "VoiceBlock":
                            VoiceBlock(ois, oos, box);
                            break;
                        case "Message":
                            Message(ois, oos, box);
                            break;
                        case "Voice":
                            Voice(ois,oos,box);
                    }
                }
            } catch (IOException | ClassNotFoundException | NullPointerException ex) {
                if (username != null) {
                    if (onlineUsers.containsKey(username)) {
                        onlineUsers.remove(username);
                        RefreshList();
                        InsertString(username, "Disconnect from server\n", Color.green);
                    }
                }
            }
        }

    }

    private void Login(ObjectInputStream ois, ObjectOutputStream oos, MailBox box) throws IOException {
        LoadUserFile();
        MailBox send = new MailBox();
        send.setTitle("Login Response");
        String username = box.getUsername();
        String password = (String) box.getInfo()[1];
        String[] info = new String[2];
        if (map.containsKey(username)) {
            InfoClass user = map.get(username);
            if (user.getPassword().equals(password)) {
                if (!onlineUsers.containsKey(username)) {
                    if (user.isBlock()) {
                        info[0] = "Your account is blocked.";
                    } else if (!user.isAccept()) {
                        info[0] = "Please wait unitl accept from server.";
                    } else {
                        info[0] = "OK";
                        onlineUsers.put(username, new Object[]{ois, oos});
                        InsertString(username, "Connect to server\n", Color.green);
                    }
                } else {
                    info[0] = "Your account is online now.";
                }
            } else {
                info[0] = "Your password is incorrect";
            }
        } else {
            info[0] = "Your username is incorrect";
        }
        send.setInfo(info);
        oos.writeObject(send);
        if (info[0].equals("OK")) {
            RefreshList();
        }
    }

    private void SignUp(ObjectInputStream ois, ObjectOutputStream oos, MailBox box) throws IOException {
        LoadUserFile();
        InfoClass user = new InfoClass();
        String username = box.getUsername();
        String password = (String) box.getInfo()[1];
        user.setPassword(password);
        user.setBlock(false);
        user.setAccept(false);
        MailBox send = new MailBox();
        send.setTitle("SignUp Response");
        String[] info = new String[2];
        if (map.containsKey(username)) {
            info[0] = "Please change your user name";
        } else {
            info[0] = "OK";
            map.put(username, user);
            SaveUserFile();
            RefreshList();
        }
        send.setInfo(info);
        oos.writeObject(send);
        if (info[0].equals("OK")) {
            RefreshList();
        }
    }

    private void SmsBlock(ObjectInputStream ois, ObjectOutputStream oos, MailBox box) {
        LoadUserFile();
        InfoClass cls = map.get(box.getUsername());
        TreeSet<String> smsBlackList = cls.getSmsBlackList();
        Object[] info = box.getInfo();
        if ((Boolean) info[1]) {
            smsBlackList.add((String) info[0]);
        } else {
            smsBlackList.remove((String) info[0]);
        }
        cls.setSmsBlackList(smsBlackList);
        SaveUserFile();
        RefreshList();
    }
    
    private void VoiceBlock(ObjectInputStream ois, ObjectOutputStream oos, MailBox box) {
        LoadUserFile();
        InfoClass cls = map.get(box.getUsername());
        TreeSet<String> voiceBlackList = cls.getVoiceBlackList();
        Object[] info = box.getInfo();
        if ((Boolean) info[1]) {
            voiceBlackList.add((String) info[0]);
        } else {
            voiceBlackList.remove((String) info[0]);
        }
        cls.setVoiceBlackList(voiceBlackList);
        SaveUserFile();
        RefreshList();
    }

    private void Message(ObjectInputStream ois, ObjectOutputStream oos, MailBox box) throws IOException {
        Object[] info = box.getInfo();
        String user = box.getUsername() + " to " + info[0];
        String message = (String) info[1];
        InsertString(user, message + "\n", Color.black);
        InfoClass cls = map.get((String) info[0]);
        TreeSet<String> set = cls.getSmsBlackList();
        if (!set.contains(box.getUsername())) {
            Object[] tmp = onlineUsers.get((String) info[0]);
            ObjectOutputStream send = (ObjectOutputStream) tmp[1];
            send.writeObject(box);
        }
    }
    
    private void Voice(ObjectInputStream ois, ObjectOutputStream oos, MailBox box) throws IOException, NullPointerException{
        Object[] info = box.getInfo();
        InfoClass cls = map.get((String) info[0]);
        TreeSet<String> set = cls.getVoiceBlackList();
        if (!set.contains(box.getUsername())) {
            Object[] tmp = onlineUsers.get((String) info[0]);
            ObjectOutputStream send = (ObjectOutputStream) tmp[1];
            send.writeObject(box);
        }
    }

    private synchronized void InsertString(String user, String msg, Color color) {
        try {
            Document doc = txt_conversation.getDocument();
            Style redStyle = txt_conversation.addStyle("redStyle", null);
            Style style = txt_conversation.addStyle("style", null);
            StyleConstants.setForeground(redStyle, Color.red);
            StyleConstants.setForeground(style, color);
            doc.insertString(doc.getLength(), "<" + user + ">: ", redStyle);
            ArrayList<String> msgMain = new ArrayList<>();
            msgMain.add(msg);
            for (int i = 0; i < smiles.length; i++) {
                ArrayList<String> msgSplit = new ArrayList<>();
                String smile = smiles[i];
                for (String tmp : msgMain) {
                    for (int j = 0; j < tmp.length();) {
                        int index = tmp.indexOf(smile, j);
                        if (index < 0) {
                            msgSplit.add(tmp.substring(j));
                            break;
                        }
                        msgSplit.add(tmp.substring(j, index));
                        msgSplit.add(tmp.substring(index, index + smile.length()));
                        j = index + smile.length();
                    }
                }
                msgMain = new ArrayList<>(msgSplit);
            }
            for (String tmp : msgMain) {
                int index = IndexOfSmile(tmp);
                if (index > 0) {
                    txt_conversation.setCaretPosition(doc.getLength());
                    txt_conversation.insertIcon(new ImageIcon(getClass().getResource(index + ".png")));
                } else {
                    doc.insertString(doc.getLength(), tmp, style);
                }
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    private int IndexOfSmile(String str) {
        for (int i = 0; i < smiles.length; i++) {
            if (smiles[i].equals(str)) {
                return i + 1;
            }
        }
        return -1;
    }

    private void LoadUserFile() {
        if (path.toFile().exists()) {
            try {
                FileInputStream fis = new FileInputStream(path.toFile());
                ObjectInputStream ois = new ObjectInputStream(fis);
                map = (TreeMap<String, InfoClass>) ois.readObject();
                ois.close();
                fis.close();
            } catch (IOException | ClassNotFoundException ex) {
                JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    private void SaveUserFile() {
        try {
            FileOutputStream fos = new FileOutputStream(path.toFile());
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            oos.writeObject(map);
            oos.close();
            fos.close();
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_send;
    private javax.swing.JCheckBox chk_accept;
    private javax.swing.JCheckBox chk_block;
    private javax.swing.ButtonGroup grp_users;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel lbl_address;
    private javax.swing.JPanel pnl_setting;
    private javax.swing.JPanel pnl_smile;
    private javax.swing.JPanel pnl_users;
    private javax.swing.JScrollPane scr_conversation;
    private javax.swing.JScrollPane scr_users;
    private javax.swing.JTextPane txt_conversation;
    private javax.swing.JTextField txt_message;
    // End of variables declaration//GEN-END:variables
}
